#define msize 20

eeprom u8 ee_t[msize] @0x0A;
eeprom u8 wrt;
eeprom struct my_structure ee @0x0A+msize;
struct my_structure pm;

u8 ee_t_wt (u8 databyte)
{
 u8 i; 

 for(i=0;i<msize;i++)
 {
  if(ee_t[i]!=0xff)
  {
   ee_t[i]=0xff;
   if(i<msize-1)ee_t[i+1] = databyte;
   else         ee_t[0]   = databyte;
   return 1;
  }
 }
 ee_t[0] = databyte;
 return 0;
}
u8 ee_trd ()
{
 u8 i;
 for(i=0;i<msize;i++)
 {
  if(ee_t[i]!=0xff)return ee_t[i];
 }
 return 0; 
}

#define wrtval 0x2b
void ee_init()
{
 if(wrt!=wrtval)
 {
  ee_t_wt(25);  
  
  ee.k_amplifier = K_AMPLIFIER;
  ee.maxtc       = MAXTC;
  ee.offset      = OFFSET;
  ee.cpadc       = CPADC; 
  ee.r_irn       = R_IRN;
  
  wrt = wrtval;
 }
}