 #define lp  5
 #define lh  50
 #define lr  3 
      
 #define noc 2
 #define key0   PINB.4
 #define key1   PINB.5

 u8 kb_timer;  
 volatile enum btns {prs, rls, hold} btn[noc];

 void scan_keys ()
 {
  static u8 count[noc*3];
  u8 key_st[noc];  
  u8 i;  

  key_st[0] = key0;
  key_st[1] = key1; 

  for(i=0;i<noc;i++)
  {
   if ((!key_st[i])&&(!count[i*3+2])) {count[i*3]++;count[i*3+2]=lr;}
   else if((key_st[i])&&(!count[i*3+2])) {count[i*3]=count[i*3+1]=0;btn[i]=rls;}
   if ((count[i*3]>lp)&&(btn[i]!=hold)) {btn[i]=prs; count[i*3]=0; count[i*3+1]++;}
   if (count[i*3+1]>lh) {btn[i]=hold; count[i*3+1]=0;}
   if (count[i*3+2])count[i*3+2]--;
  }   
 }   

 void kb_input(u16 *value, const u16 min_value, const u16 max_value, const u8 step, const u16 hstep, const u8 rfq)
 {
  static bit btp0,btp1;
  static bit btn_trg1;  
   
  if(btn[0]==prs&&btn[1]==prs&&!btn_trg1){btp1=btp0=0;}

  if(btn[0]==prs&&btn[1]==rls&&!btn_trg1)
  {
   btn_trg1=1;
   btp0 = 1;
  }
  else if(btn[0]==rls&&btn[1]==prs&&!btn_trg1)
  {
   btn_trg1=1;
   btp1 = 1;
  }
  else if(btn[0]==hold&&btn[1]==rls)
  {
   btp1=btp0=0;
   if(!kb_timer)
   {
    kb_timer=rfq;
    if(*value>min_value+hstep)*value-=hstep;
    else *value=min_value;
   }
  }
  else if(btn[0]==rls&&btn[1]==hold)
  {
   btp1=btp0=0;
   if(!kb_timer)
   {
    kb_timer=rfq;
    if(*value<max_value-hstep)*value+=hstep;
    else *value=max_value;
   }  
  }

  if(btn[0]==rls&&btn[1]==rls)btn_trg1=0;
  if(!btn_trg1)
  {
   if(btp0)
   {
    btp1=btp0=0;
    if(*value>min_value+step)*value-=step;
    else *value=min_value;
   }
   else if(btp1)
   {
    btp1=btp0=0; 
    if(*value<max_value-step)*value+=step; 
    else *value=max_value; 
   } 
  }   
 }
 