
bool read_adc(u16 *result)
{
 static u32 adc_cps=0;
 static u8 adc_cnt=0;
 static bit trg=0;  
 
 if(!trg)
 {
  trg=1;
  adc_cps=adc_cnt=0;
  ADCSRA.ADSC=1;
 }
 else
 {
  if(!ADCSRA.ADSC)
  { 
   adc_cps+= ADCW;
   adc_cnt++;
   ADCSRA.ADSC=1;  
   
   if(adc_cnt>0x0f) 
   { 
    *result = adc_cps>>4; 

    trg=0; 
    return 1; 
   } 
  } 
 }       
 
 return 0; 
}

