
#ifdef debug
u8 dbuf[3]={0,1,2};
#endif
#ifndef debug
u8 dbuf[3]={'_','_','_'};
#endif
bit ssg_pl;
u8 dpp=0;

void display_data()
{
 static u8 pc; u8 tmp;

 (pc)?(pc--):(pc = 2);

 DDR2=DDR1=DDR0 = 0;

 switch (dbuf[pc])
 {
  case 0: tmp = 0b0000001; break;
  case 1: tmp = 0b1001111; break;
  case 2: tmp = 0b0010010; break;
  case 3: tmp = 0b0000110; break;
  case 4: tmp = 0b1001100; break;
  case 'S':
  case 5: tmp = 0b0100100; break;
  case 6: tmp = 0b0100000; break;
  case 7: tmp = 0b0001111; break;
  case 8: tmp = 0b0000000; break;
  case 9: tmp = 0b0000100; break;

  case 10: tmp = 0b0111111; break;
  case 11: tmp = 0b1011111; break;
  case 12: tmp = 0b1101111; break;
  case 13: tmp = 0b1110111; break;
  case 14: tmp = 0b1111011; break;
  case 15: tmp = 0b1111101; break;
  case 16: tmp = 0b1111110; break;

  case ' ': tmp = 0b1111111; break;
  case 'v':
  case 'u': tmp = 0b1100011; break;
  case 'c': tmp = 0b1110010; break;
  case 'b': tmp = 0b1100000; break;
  case 't': tmp = 0b1110000; break;
  case 'l': tmp = 0b1110011; break;
  case 'o': tmp = 0b1100010; break;
  case 'A': tmp = 0b0001000; break;
  case 'H': tmp = 0b1001000; break;
  case 'C': tmp = 0b0110001; break;
  case 'P': tmp = 0b0011000; break;
  case 'E': tmp = 0b0110000; break;
  case 'U': tmp = 0b1000001; break;
  case 'f':
  case 'F': tmp = 0b0111000; break;
  case 'L': tmp = 0b1110001; break;
  case 'r': tmp = 0b1111010; break;
  case '_': tmp = 0b1110111; break;
  case 'd': tmp = 0b1000010; break;
  case 'n': tmp = 0b1101010; break;
  case 'G': tmp = 0b0100001; break;
  case 'N': tmp = 0b0001001; break;
  case 'O': tmp = 0b0000001; break;
  case 'i': tmp = 0b1111011; break;
  case 'I': tmp = 0b1111001; break;
  case 'J': tmp = 0b1000111; break;
  case 'h': tmp = 0b1101000; break;
  default:  tmp = 0b1111110; break; //-
 }

 if(ssg_pl)
 {
  tmp = ~tmp;
  DP=0;
  N2=N1=N0=1;
  switch (pc)
  {
   case 0:             N0=0; if(dpp == 0) {DP=1;} break;
   case 1:             N1=0; if(dpp == 1) {DP=1;} break;
   case 2: if (dbuf[2])N2=0; if(dpp == 2) {DP=1;} break;   
  }
 }
 else
 {
  DP=1;
  N2=N1=N0=0;
  switch (pc)
  {
   case 0:             N0=1; if(dpp == 0) {DP=0;} break;
   case 1:             N1=1; if(dpp == 1) {DP=0;} break;
   case 2: if (dbuf[2])N2=1; if(dpp == 2) {DP=0;} break;   
  }
 }

 (tmp&(1<<6))?(A=1):(A=0);
 (tmp&(1<<5))?(B=1):(B=0);
 (tmp&(1<<4))?(C=1):(C=0);
 (tmp&(1<<3))?(D=1):(D=0);
 (tmp&(1<<2))?(E=1):(E=0);
 (tmp&(1<<1))?(F=1):(F=0);
 (tmp&(1<<0))?(G=1):(G=0);

 DDR2=DDR1=DDR0 = 1; 

}

void detect_7seg_polarity()
{
 u8 n=0,i;

 A=B=C=D=E=F=G=DP = 0;
 DDR2=DDR1=DDR0 = 0;
 N2=N1=N0 = 1;
 
 for(i=0xff;i;i--)
 {
  if(!IDR0)n++;
  else if(n)n--;
 }
  if(n>0xff/2)ssg_pl=0;//CA
  else ssg_pl=1;       //CC
}

void convert_data (s16 d)
{
 u8 k; 

 if(d<0)
 { 
  dbuf[2]='-'; 
  d = -d;  
  for (k=0;k<2;k++)
  {
   dbuf[k]=d%10;
   d/=10;
  }   
 }    
 else
 for (k=0;k<3;k++)
 {
  dbuf[k]=d%10;
  d/=10;
 }   
}